(define (domain Elevators)
  (:requirements :typing :fluents)
  (:types 	elevator - object 
		slow-elevator fast-elevator - elevator
   		passenger - object
          	floor - object
         )

(:predicates 
	(passenger-at ?person - passenger ?floor - floor)
	(boarded ?person - passenger ?lift - elevator)
	(lift-at ?lift - elevator ?floor - floor)
	(reachable-floor ?lift - elevator ?floor - floor)
	(above ?floor1 - floor ?floor2 - floor)
)

(:functions 
	(numfloor ?f - floor)
        (total-energy) 
        (energy-burn ?lift - elevator)
	(passengers ?lift - elevator) 
	(capacity ?lift - elevator) 
)

(:action move-up-slow
  :parameters (?lift - slow-elevator ?f1 - floor ?f2 - floor )
  :precondition (and (lift-at ?lift ?f1) 
  	     	  (> (numfloor ?f2) (numfloor ?f1)) 
		  (reachable-floor ?lift ?f2))
  :effect (and (lift-at ?lift ?f2) 
  	       (not (lift-at ?lift ?f1))
	       (increase (total-energy) (* (energy-burn ?lift) (- (numfloor ?f2) (numfloor ?f1)))) ))

(:action move-down-slow
  :parameters (?lift - slow-elevator ?f1 - floor ?f2 - floor )
  :precondition (and (lift-at ?lift ?f1) 
  	     	  (< (numfloor ?f2) (numfloor ?f1)) 
  	     	  (reachable-floor ?lift ?f2))
  :effect (and (lift-at ?lift ?f2) 
  	       (not (lift-at ?lift ?f1))
	       (increase (total-energy) (* (energy-burn ?lift) (- (numfloor ?f1) (numfloor ?f2)))) ))

(:action move-up-fast
  :parameters (?lift - fast-elevator ?f1 - floor ?f2 - floor )
  :precondition (and (lift-at ?lift ?f1) 
  	     	  (> (numfloor ?f2) (numfloor ?f1)) 
  	     	  (reachable-floor ?lift ?f2))
  :effect (and (lift-at ?lift ?f2) 
  	       (not (lift-at ?lift ?f1))
	       (increase (total-energy) (* (energy-burn ?lift) (- (numfloor ?f2) (numfloor ?f1)))) ))

(:action move-down-fast
  :parameters (?lift - fast-elevator ?f1 - floor ?f2 - floor )
  :precondition (and (lift-at ?lift ?f1) 
  	     	  (< (numfloor ?f2) (numfloor ?f1)) 
		  (reachable-floor ?lift ?f2))
  :effect (and (lift-at ?lift ?f2) 
  	       (not (lift-at ?lift ?f1))
	       (increase (total-energy) (* (energy-burn ?lift) (- (numfloor ?f1) (numfloor ?f2)))) ))

(:action board
  :parameters (?p - passenger ?lift - elevator ?f - floor)
  :precondition (and  (lift-at ?lift ?f) 
  	     	   (passenger-at ?p ?f)  
		   (< (passengers ?lift) (capacity ?lift)))
  :effect (and (not (passenger-at ?p ?f))
  	       (boarded ?p ?lift)
	       (increase (passengers ?lift) 1)))

(:action leave 
  :parameters (?p - passenger ?lift - elevator ?f - floor)
  :precondition (and  (lift-at ?lift ?f) 
  	     	   (boarded ?p ?lift))
  :effect (and (passenger-at ?p ?f) 
  	       (not (boarded ?p ?lift)) 
	       (decrease (passengers ?lift) 1)))
  
)
