(define (domain TPP)
(:requirements :typing :fluents :durative-actions :timed-initial-literals) 
(:types depot market - place 
	truck goods - locatable)

(:predicates (at ?t - truck ?p - place)
        (available ?m - place))

(:functions (on-sale ?g - goods ?m - market)
	    (drive-cost ?p1 ?p2 - place)
	    (price ?g - goods ?m - market)
	    (bought ?g - goods)
	    (request ?g - goods)
	    (total-cost))

(:durative-action drive
 :parameters (?t - truck ?from ?to - place)
 :duration (= ?duration (drive-cost ?from ?to))
 :condition (and (at end (available ?to)) (at start (at ?t ?from)))
 :effect (and (at start (not (at ?t ?from))) (at end (at ?t ?to))
	      (at end (increase (total-cost) (drive-cost ?from ?to)))))

(:durative-action buy-allneeded
 :parameters (?t - truck ?g - goods ?m - market)
 :duration (= ?duration 1.0)
 :condition (and (at start (> (on-sale ?g ?m) (- (request ?g) (bought ?g))))
		 (at start (> (on-sale ?g ?m) 0)) (over all (at ?t ?m)))
 :effect (and (at start (decrease (on-sale ?g ?m) 
				  (- (request ?g) (bought ?g))))
	     (at start (increase (total-cost) (* (- (request ?g) (bought ?g)) 
						 (price ?g ?m))))
	     (at start (assign (bought ?g) (request ?g)))))

(:durative-action buy-all
 :parameters (?t - truck ?g - goods ?m - market)
 :duration (= ?duration 1.0)
 :condition (and (at start (> (on-sale ?g ?m) 0)) (at start (<= (on-sale ?g ?m) (- (request ?g) (bought ?g)))) (over all (at ?t ?m)))
 :effect (and (at start (assign (on-sale ?g ?m) 0))
	      (at start (increase (total-cost) (* (on-sale ?g ?m) (price ?g ?m))))
	      (at start (increase (bought ?g) (on-sale ?g ?m)))))
)
